use <roundedBox.scad>

width = 122;
length = 122;
radius = 6;
thk = 1.75;
height = 14 + thk;
pillarRad = 4;
counterBoreDia = 6;
counterBoreDepth = height - 5;
screwClearanceDia = 3.5;

difference() {
    union() {
        roundedBox(width, length, height, radius, thk);
        pillars();
        
        // liPo restraints
        mirror([1, 0, 0]) {
            translate([-55, -38.5, 0])
                cube([9, 2.5, height - 1]);
            translate([-48.5, -56.5, 0])
                cube([2.5, 19.5, height - 1]);
            translate([-40, -35.5, 0])
                cube([10, 2.5, height - 1]);
            translate([-36.25, -35.5, 0])
                cube([2.5, 8, height - 1]);
            translate([-12, -35.5, 0])
                cube([10, 2.5, height - 1]);
            translate([-10, -35.5, 0])
                cube([2.5, 8, height - 1]);
            translate([24, -56.5, 0])
                cube([2.5, 15, height - 1]);
            translate([24, -50, 0])
                cube([8, 2.5, height - 1]);
            translate([-48, -61, thk + radius])
                cube([75, 4.5, 2.5]);
            translate([-48, -61, height - 3.5])
                cube([75, 4.5, 2.5]);
        }
    }
    counterBores();
}

module pillars() {
    translate([-width/2+radius+pillarRad, -length/2+radius+pillarRad, 0])
        pillar(pillarRad * 2, height - 0.5, screwClearanceDia, height -1);
    translate([-width/2+radius+pillarRad, length/2-radius-pillarRad, 0])
        pillar(pillarRad * 2, height - 0.5, screwClearanceDia, height -1);
    translate([width/2-radius-pillarRad, -length/2+radius+pillarRad, 0])
        pillar(pillarRad * 2, height - 0.5, screwClearanceDia, height -1);
    translate([width/2-radius-pillarRad, length/2-radius-pillarRad, 0])
        pillar(pillarRad * 2, height - 0.5, screwClearanceDia, height -1);
}

module counterBores() {
    translate([-width/2+radius+pillarRad, -length/2+radius+pillarRad, 0])
        counterBore(counterBoreDia, counterBoreDepth);
    translate([-width/2+radius+pillarRad, length/2-radius-pillarRad, 0])
        counterBore(counterBoreDia, counterBoreDepth);
    translate([width/2-radius-pillarRad, -length/2+radius+pillarRad, 0])
        counterBore(counterBoreDia, counterBoreDepth);
    translate([width/2-radius-pillarRad, length/2-radius-pillarRad, 0])
        counterBore(counterBoreDia, counterBoreDepth);
}
