difference() {
    union() {
        roundedBox();
        pillar();
    }
    counterBore();
}

module roundedBox(width = 100, length = 100, height = 30, radius = 5, th = 2) {
    difference() {
        roundedBoxBlank(width, length, height, radius);
        translate([0, 0, th])
            roundedBoxBlank(width-th*2, length-th*2, height, radius-th);
    }
}
module roundedBoxBlank(width = 100, length = 100, height = 30, radius = 5) {
    hull() {
        translate([radius-width/2, radius-length/2, radius]) {
            sphere(r = radius);
            cylinder(r = radius, h = height-radius);
        }
        translate([width/2 - radius, radius-length/2, radius]) {
            sphere(r = radius);
            cylinder(r = radius, h = height-radius);
        }
        translate([radius-width/2, length/2 - radius, radius]) {
            sphere(r = radius);
            cylinder(r = radius, h = height-radius);
        }
        translate([width/2 - radius, length/2 - radius, radius]) {
            sphere(r = radius);
            cylinder(r = radius, h = height-radius);
        }
    }
}

module pillar(diam = 8, height = 30, holeDia = 3, holeDepth = 20) {
    difference() {
        cylinder(d = diam, h = height);
        translate([0, 0, height - holeDepth])
            cylinder(d = holeDia, h = holeDepth + 0.1);
    }
}

module counterBore(counterBoreDia = 5, counterBoreDepth = 25) {
    translate([0, 0, -0.1])
        cylinder(d = counterBoreDia, h = counterBoreDepth + 0.1);
}
    
    